# Class BioShapeCollection

java.lang.Object
org.jmol.shape.Shape
org.jmol.shapebio.BioShapeCollection

Direct Known Subclasses:
  `Backbone, Ribbons, Rockets, Strands, Trace`

public abstract class BioShapeCollection extends Shape
When a Cartoon is instantiated with a call to setSize(), it creates an BioShapeCollection for each BioPolymer in the model set. It is these shapes that are the real "shapes". Unlike other shapes, which are indexed by atom and throughout the entire model set, these shapes are indexed by residue and are restricted to a given BioPolymer within a given Model.

## Field Summary

Fields
Modifier and Type
Field
Description
`BioShape[]`
`bioShapes`

### Fields inherited from class Shape

`bsColixSet, bsSizeSet, isBioShape, ms, myType, RADIUS_MAX, shapeID, translucentAllowed, translucentLevel, vf, vwr`

## Constructor Summary

Constructors
Constructor
Description
`BioShapeCollection()`

## Method Summary

Modifier and Type
Method
Description
`void`
`findNearestAtomIndex(int xMouse, int yMouse, Atom[] closest, BS bsNot)`
`BioShape`
`getBioShape(int i)`
`String`
`getShapeState()`
`int`
`getSizeG(Group group)`
`final void`
`initModelSet()`
`void`
`initShape()`
`void`
`replaceGroup(Group g0, Group g1)`
`void`
`setAtomClickability()`
`void`
`setModelVisibilityFlags(BS bsModels)`
`protected void`
`setPropBSC(String propertyName, Object value, BS bsSelected)`
`void`
`setProperty(String propertyName, Object value, BS bsSelected)`
`void`
`setShapeSizeRD(int size, RadiusData rd, BS bsSelected)`

### Methods inherited from class Shape

`appendCmd, checkBoundsMinMax, checkObjectClicked, checkObjectDragged, checkObjectHovered, coordinateInRange, encodeColor, getColix, getColixA, getColixB, getColixI, getColorCommand, getColorCommandUnk, getFontCommand, getIndexFromName, getProperty, getPropertyData, getPropShape, getShapeDetail, getSize, getTranslucentLabel, initializeShape, setModelSet, setProperties, setPropS, setSize, setSizeRD, wasClicked`

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### bioShapes

public BioShape[] bioShapes

## Constructor Details

### BioShapeCollection

public BioShapeCollection()

## Method Details

### initModelSet

public final void initModelSet()

Overrides:
  `initModelSet` in class `Shape`

### initShape

public void initShape()

Specified by:
  `initShape` in class `Shape`

### getSizeG

public int getSizeG(Group group)

Overrides:
  `getSizeG` in class `Shape`
Parameters:
  `group` -
Returns:
  size

### replaceGroup

public void replaceGroup(Group g0, Group g1)

Overrides:
  `replaceGroup` in class `Shape`
Parameters:
  `g0` -
  `g1` -

### setShapeSizeRD

public void setShapeSizeRD(int size, RadiusData rd, BS bsSelected)

Overrides:
  `setShapeSizeRD` in class `Shape`

### setProperty

public void setProperty(String propertyName, Object value, BS bsSelected)

Specified by:
  `setProperty` in class `Shape`

### setPropBSC

protected void setPropBSC(String propertyName, Object value, BS bsSelected)

### getShapeState

public String getShapeState()

Specified by:
  `getShapeState` in class `Shape`

### findNearestAtomIndex

public void findNearestAtomIndex(int xMouse, int yMouse, Atom[] closest, BS bsNot)

Overrides:
  `findNearestAtomIndex` in class `Shape`
Parameters:
  `xMouse` -
  `yMouse` -
  `closest` -
  `bsNot` -

### setModelVisibilityFlags

public void setModelVisibilityFlags(BS bsModels)

Overrides:
  `setModelVisibilityFlags` in class `Shape`
Parameters:
  `bsModels` -

### setAtomClickability

public void setAtomClickability()

Overrides:
  `setAtomClickability` in class `Shape`

### getBioShape

public BioShape getBioShape(int i)